--- old/usr/src/uts/common/fs/zfs/arc.c	Mon Aug  5 17:26:46 2019
+++ new/usr/src/uts/common/fs/zfs/arc.c	Mon Aug  5 17:26:46 2019
@@ -6054,14 +6797,20 @@
 	refcount_destroy(&arc_mfu_ghost->arcs_size);
 	refcount_destroy(&arc_l2c_only->arcs_size);
 
-	multilist_destroy(arc_mru->arcs_list[ARC_BUFC_METADATA]);
-	multilist_destroy(arc_mru_ghost->arcs_list[ARC_BUFC_METADATA]);
-	multilist_destroy(arc_mfu->arcs_list[ARC_BUFC_METADATA]);
-	multilist_destroy(arc_mfu_ghost->arcs_list[ARC_BUFC_METADATA]);
-	multilist_destroy(arc_mru->arcs_list[ARC_BUFC_DATA]);
-	multilist_destroy(arc_mru_ghost->arcs_list[ARC_BUFC_DATA]);
-	multilist_destroy(arc_mfu->arcs_list[ARC_BUFC_DATA]);
-	multilist_destroy(arc_mfu_ghost->arcs_list[ARC_BUFC_DATA]);
+	for (arcs = ARC_BUFC_DATA; arcs < ARC_BUFC_NUMTYPES; ++arcs) {
+		multilist_destroy(arc_mru->arcs_list[arcs]);
+		multilist_destroy(arc_mru_ghost->arcs_list[arcs]);
+		multilist_destroy(arc_mfu->arcs_list[arcs]);
+		multilist_destroy(arc_mfu_ghost->arcs_list[arcs]);
+		multilist_destroy(arc_l2c_only->arcs_list[arcs]);
+
+		refcount_destroy(&arc_anon->arcs_esize[arcs]);
+		refcount_destroy(&arc_mru->arcs_esize[arcs]);
+		refcount_destroy(&arc_mru_ghost->arcs_esize[arcs]);
+		refcount_destroy(&arc_mfu->arcs_esize[arcs]);
+		refcount_destroy(&arc_mfu_ghost->arcs_esize[arcs]);
+		refcount_destroy(&arc_l2c_only->arcs_esize[arcs]);
+	}
 }
 
 uint64_t
@@ -6121,7 +6870,10 @@
 
 	arc_c = arc_c_max;
 	arc_p = (arc_c >> 1);
+	arc_size = 0;
 
+	/* limit ddt meta-data to 1/4 of the arc capacity */
+	arc_ddt_limit = arc_c_max / 4;
 	/* limit meta-data to 1/4 of the arc capacity */
 	arc_meta_limit = arc_c_max / 4;
 
@@ -6135,6 +6887,12 @@
 #endif
 
 	/* Allow the tunable to override if it is reasonable */
+	if (zfs_arc_ddt_limit > 0 && zfs_arc_ddt_limit <= arc_c_max)
+		arc_ddt_limit = zfs_arc_ddt_limit;
+	arc_ddt_evict_threshold =
+	    zfs_arc_segregate_ddt ? &arc_ddt_limit : &arc_meta_limit;
+
+	/* Allow the tunable to override if it is reasonable */
 	if (zfs_arc_meta_limit > 0 && zfs_arc_meta_limit <= arc_c_max)
 		arc_meta_limit = zfs_arc_meta_limit;
 
@@ -6229,6 +6987,8 @@
 		arc_ksp = NULL;
 	}
 
+	taskq_destroy(arc_flush_taskq);
+
 	mutex_destroy(&arc_reclaim_lock);
 	cv_destroy(&arc_reclaim_thread_cv);
 	cv_destroy(&arc_reclaim_waiters_cv);
@@ -6382,6 +7142,95 @@
  *
  * These three functions determine what to write, how much, and how quickly
  * to send writes.
+ *
+ * L2ARC persistency:
+ *
+ * When writing buffers to L2ARC, we periodically add some metadata to
+ * make sure we can pick them up after reboot, thus dramatically reducing
+ * the impact that any downtime has on the performance of storage systems
+ * with large caches.
+ *
+ * The implementation works fairly simply by integrating the following two
+ * modifications:
+ *
+ * *) Every now and then we mix in a piece of metadata (called a log block)
+ *    into the L2ARC write. This allows us to understand what's been written,
+ *    so that we can rebuild the arc_buf_hdr_t structures of the main ARC
+ *    buffers. The log block also includes a "2-back-reference" pointer to
+ *    he second-to-previous block, forming a back-linked list of blocks on
+ *    the L2ARC device.
+ *
+ * *) We reserve SPA_MINBLOCKSIZE of space at the start of each L2ARC device
+ *    for our header bookkeeping purposes. This contains a device header,
+ *    which contains our top-level reference structures. We update it each
+ *    time we write a new log block, so that we're able to locate it in the
+ *    L2ARC device. If this write results in an inconsistent device header
+ *    (e.g. due to power failure), we detect this by verifying the header's
+ *    checksum and simply drop the entries from L2ARC.
+ *
+ * Implementation diagram:
+ *
+ * +=== L2ARC device (not to scale) ======================================+
+ * |       ___two newest log block pointers__.__________                  |
+ * |      /                                   \1 back   \latest           |
+ * |.____/_.                                   V         V                |
+ * ||L2 dev|....|lb |bufs |lb |bufs |lb |bufs |lb |bufs |lb |---(empty)---|
+ * ||   hdr|      ^         /^       /^        /         /                |
+ * |+------+  ...--\-------/  \-----/--\------/         /                 |
+ * |                \--------------/    \--------------/                  |
+ * +======================================================================+
+ *
+ * As can be seen on the diagram, rather than using a simple linked list,
+ * we use a pair of linked lists with alternating elements. This is a
+ * performance enhancement due to the fact that we only find out of the
+ * address of the next log block access once the current block has been
+ * completely read in. Obviously, this hurts performance, because we'd be
+ * keeping the device's I/O queue at only a 1 operation deep, thus
+ * incurring a large amount of I/O round-trip latency. Having two lists
+ * allows us to "prefetch" two log blocks ahead of where we are currently
+ * rebuilding L2ARC buffers.
+ *
+ * On-device data structures:
+ *
+ * L2ARC device header:	l2arc_dev_hdr_phys_t
+ * L2ARC log block:	l2arc_log_blk_phys_t
+ *
+ * L2ARC reconstruction:
+ *
+ * When writing data, we simply write in the standard rotary fashion,
+ * evicting buffers as we go and simply writing new data over them (writing
+ * a new log block every now and then). This obviously means that once we
+ * loop around the end of the device, we will start cutting into an already
+ * committed log block (and its referenced data buffers), like so:
+ *
+ *    current write head__       __old tail
+ *                        \     /
+ *                        V    V
+ * <--|bufs |lb |bufs |lb |    |bufs |lb |bufs |lb |-->
+ *                         ^    ^^^^^^^^^___________________________________
+ *                         |                                                \
+ *                   <<nextwrite>> may overwrite this blk and/or its bufs --'
+ *
+ * When importing the pool, we detect this situation and use it to stop
+ * our scanning process (see l2arc_rebuild).
+ *
+ * There is one significant caveat to consider when rebuilding ARC contents
+ * from an L2ARC device: what about invalidated buffers? Given the above
+ * construction, we cannot update blocks which we've already written to amend
+ * them to remove buffers which were invalidated. Thus, during reconstruction,
+ * we might be populating the cache with buffers for data that's not on the
+ * main pool anymore, or may have been overwritten!
+ *
+ * As it turns out, this isn't a problem. Every arc_read request includes
+ * both the DVA and, crucially, the birth TXG of the BP the caller is
+ * looking for. So even if the cache were populated by completely rotten
+ * blocks for data that had been long deleted and/or overwritten, we'll
+ * never actually return bad data from the cache, since the DVA with the
+ * birth TXG uniquely identify a block in space and time - once created,
+ * a block is immutable on disk. The worst thing we have done is wasted
+ * some time and memory at l2arc rebuild to reconstruct outdated ARC
+ * entries that will get dropped from the l2arc as it is being updated
+ * with new blocks.
  */
 
 static boolean_t
@@ -6447,14 +7296,20 @@
 	return (next);
 }
 
+typedef enum l2ad_feed {
+	L2ARC_FEED_ALL = 1,
+	L2ARC_FEED_DDT_DEV,
+	L2ARC_FEED_NON_DDT_DEV,
+} l2ad_feed_t;
+
 /*
  * Cycle through L2ARC devices.  This is how L2ARC load balances.
  * If a device is returned, this also returns holding the spa config lock.
  */
 static l2arc_dev_t *
-l2arc_dev_get_next(void)
+l2arc_dev_get_next(l2ad_feed_t feed_type)
 {
-	l2arc_dev_t *first, *next = NULL;
+	l2arc_dev_t *start = NULL, *next = NULL;
 
 	/*
 	 * Lock out the removal of spas (spa_namespace_lock), then removal
@@ -6468,30 +7323,55 @@
 	if (l2arc_ndev == 0)
 		goto out;
 
-	first = NULL;
-	next = l2arc_dev_last;
-	do {
-		/* loop around the list looking for a non-faulted vdev */
-		if (next == NULL) {
-			next = list_head(l2arc_dev_list);
-		} else {
-			next = list_next(l2arc_dev_list, next);
-			if (next == NULL)
-				next = list_head(l2arc_dev_list);
-		}
+	if (feed_type == L2ARC_FEED_DDT_DEV)
+		next = l2arc_ddt_dev_last;
+	else
+		next = l2arc_dev_last;
 
-		/* if we have come back to the start, bail out */
-		if (first == NULL)
-			first = next;
-		else if (next == first)
-			break;
+	/* figure out what the next device we look at should be */
+	if (next == NULL)
+		next = list_head(l2arc_dev_list);
+	else if (list_next(l2arc_dev_list, next) == NULL)
+		next = list_head(l2arc_dev_list);
+	else
+		next = list_next(l2arc_dev_list, next);
+	ASSERT(next);
 
-	} while (vdev_is_dead(next->l2ad_vdev));
+	/* loop through L2ARC devs looking for the one we need */
+	/* LINTED(E_CONSTANT_CONDITION) */
+	while (1) {
+		if (next == NULL) /* reached list end, start from beginning */
+			next = list_head(l2arc_dev_list);
 
-	/* if we were unable to find any usable vdevs, return NULL */
-	if (vdev_is_dead(next->l2ad_vdev))
-		next = NULL;
+		if (start == NULL) { /* save starting dev */
+			start = next;
+		} else if (start == next) { /* full loop completed - stop now */
+			next = NULL;
+			if (feed_type == L2ARC_FEED_DDT_DEV) {
+				l2arc_ddt_dev_last = NULL;
+				goto out;
+			} else {
+				break;
+			}
+		}
 
+		if (!vdev_is_dead(next->l2ad_vdev) && !next->l2ad_rebuild) {
+			if (feed_type == L2ARC_FEED_DDT_DEV) {
+				if (vdev_type_is_ddt(next->l2ad_vdev)) {
+					l2arc_ddt_dev_last = next;
+					goto out;
+				}
+			} else if (feed_type == L2ARC_FEED_NON_DDT_DEV) {
+				if (!vdev_type_is_ddt(next->l2ad_vdev)) {
+					break;
+				}
+			} else {
+				ASSERT(feed_type == L2ARC_FEED_ALL);
+				break;
+			}
+		}
+		next = list_next(l2arc_dev_list, next);
+	}
 	l2arc_dev_last = next;
 
 out:
@@ -6544,6 +7424,7 @@
 	arc_buf_hdr_t *head, *hdr, *hdr_prev;
 	kmutex_t *hash_lock;
 	int64_t bytes_dropped = 0;
+	l2arc_log_blk_buf_t *lb_buf;
 
 	cb = zio->io_private;
 	ASSERT3P(cb, !=, NULL);
@@ -6640,10 +7521,14 @@
 	kmem_cache_free(hdr_l2only_cache, head);
 	mutex_exit(&dev->l2ad_mtx);
 
+	ASSERT(dev->l2ad_vdev != NULL);
 	vdev_space_update(dev->l2ad_vdev, -bytes_dropped, 0, 0);
 
 	l2arc_do_free_on_write();
 
+	while ((lb_buf = list_remove_tail(&cb->l2wcb_log_blk_buflist)) != NULL)
+		kmem_free(lb_buf, sizeof (*lb_buf));
+	list_destroy(&cb->l2wcb_log_blk_buflist);
 	kmem_free(cb, sizeof (l2arc_write_callback_t));
 }
 
@@ -6750,33 +7635,40 @@
 
 /*
  * This is the list priority from which the L2ARC will search for pages to
- * cache.  This is used within loops (0..3) to cycle through lists in the
+ * cache.  This is used within loops to cycle through lists in the
  * desired order.  This order can have a significant effect on cache
  * performance.
  *
- * Currently the metadata lists are hit first, MFU then MRU, followed by
- * the data lists.  This function returns a locked list, and also returns
- * the lock pointer.
+ * Currently the ddt lists are hit first (MFU then MRU),
+ * followed by metadata then by the data lists.
+ * This function returns a locked list, and also returns the lock pointer.
  */
 static multilist_sublist_t *
-l2arc_sublist_lock(int list_num)
+l2arc_sublist_lock(enum l2arc_priorities prio)
 {
 	multilist_t *ml = NULL;
 	unsigned int idx;
 
-	ASSERT(list_num >= 0 && list_num <= 3);
+	ASSERT(prio >= PRIORITY_MFU_DDT);
+	ASSERT(prio < PRIORITY_NUMTYPES);
 
-	switch (list_num) {
-	case 0:
+	switch (prio) {
+	case PRIORITY_MFU_DDT:
+		ml = arc_mfu->arcs_list[ARC_BUFC_DDT];
+		break;
+	case PRIORITY_MRU_DDT:
+		ml = arc_mru->arcs_list[ARC_BUFC_DDT];
+		break;
+	case PRIORITY_MFU_META:
 		ml = arc_mfu->arcs_list[ARC_BUFC_METADATA];
 		break;
-	case 1:
+	case PRIORITY_MRU_META:
 		ml = arc_mru->arcs_list[ARC_BUFC_METADATA];
 		break;
-	case 2:
+	case PRIORITY_MFU_DATA:
 		ml = arc_mfu->arcs_list[ARC_BUFC_DATA];
 		break;
-	case 3:
+	case PRIORITY_MRU_DATA:
 		ml = arc_mru->arcs_list[ARC_BUFC_DATA];
 		break;
 	}
@@ -6792,6 +7684,19 @@
 }
 
 /*
+ * Calculates the maximum overhead of L2ARC metadata log blocks for a given
+ * L2ARC write size. l2arc_evict and l2arc_write_buffers need to include this
+ * overhead in processing to make sure there is enough headroom available
+ * when writing buffers.
+ */
+static inline uint64_t
+l2arc_log_blk_overhead(uint64_t write_sz)
+{
+	return ((write_sz / SPA_MINBLOCKSIZE / L2ARC_LOG_BLK_ENTRIES) + 1) *
+	    L2ARC_LOG_BLK_SIZE;
+}
+
+/*
  * Evict buffers from the device write hand to the distance specified in
  * bytes.  This distance may span populated buffers, it may span nothing.
  * This is clearing a region on the L2ARC device ready for writing.
@@ -6798,7 +7703,7 @@
  * If the 'all' boolean is set, every buffer is evicted.
  */
 static void
-l2arc_evict(l2arc_dev_t *dev, uint64_t distance, boolean_t all)
+l2arc_evict_impl(l2arc_dev_t *dev, uint64_t distance, boolean_t all)
 {
 	list_t *buflist;
 	arc_buf_hdr_t *hdr, *hdr_prev;
@@ -6815,6 +7720,10 @@
 		return;
 	}
 
+	/*
+	 * We need to add in the worst case scenario of log block overhead.
+	 */
+	distance += l2arc_log_blk_overhead(distance);
 	if (dev->l2ad_hand >= (dev->l2ad_end - (2 * distance))) {
 		/*
 		 * When nearing the end of the device, evict to the end
@@ -6898,7 +7807,73 @@
 	mutex_exit(&dev->l2ad_mtx);
 }
 
+static void
+l2arc_evict_task(void *arg)
+{
+	l2arc_dev_t *dev = arg;
+	ASSERT(dev);
+
+	/*
+	 * Evict l2arc buffers asynchronously; we need to keep the device
+	 * around until we are sure there aren't any buffers referencing it.
+	 * We do not need to hold any config locks, etc. because at this point,
+	 * we are the only ones who knows about this device (the in-core
+	 * structure), so no new buffers can be created (e.g. if the pool is
+	 * re-imported while the asynchronous eviction is in progress) that
+	 * reference this same in-core structure. Also remove the vdev link
+	 * since further use of it as l2arc device is prohibited.
+	 */
+	dev->l2ad_vdev = NULL;
+	l2arc_evict_impl(dev, 0LL, B_TRUE);
+
+	/* Same cleanup as in the synchronous path */
+	list_destroy(&dev->l2ad_buflist);
+	mutex_destroy(&dev->l2ad_mtx);
+	refcount_destroy(&dev->l2ad_alloc);
+	kmem_free(dev->l2ad_dev_hdr, dev->l2ad_dev_hdr_asize);
+	kmem_free(dev, sizeof (l2arc_dev_t));
+}
+
+boolean_t zfs_l2arc_async_evict = B_TRUE;
+
 /*
+ * Perform l2arc eviction for buffers associated with this device
+ * If evicting all buffers (done at pool export time), try to evict
+ * asynchronously, and fall back to synchronous eviction in case of error
+ * Tell the caller whether to cleanup the device:
+ *  - B_TRUE means "asynchronous eviction, do not cleanup"
+ *  - B_FALSE means "synchronous eviction, done, please cleanup"
+ */
+static boolean_t
+l2arc_evict(l2arc_dev_t *dev, uint64_t distance, boolean_t all)
+{
+	/*
+	 *  If we are evicting all the buffers for this device, which happens
+	 *  at pool export time, schedule asynchronous task
+	 */
+	if (all && zfs_l2arc_async_evict) {
+		if ((taskq_dispatch(arc_flush_taskq, l2arc_evict_task,
+		    dev, TQ_NOSLEEP) == NULL)) {
+			/*
+			 * Failed to dispatch asynchronous task
+			 * cleanup, evict synchronously
+			 */
+			l2arc_evict_impl(dev, distance, all);
+		} else {
+			/*
+			 * Successful dispatch, vdev space updated
+			 */
+			return (B_TRUE);
+		}
+	} else {
+		/* Evict synchronously */
+		l2arc_evict_impl(dev, distance, all);
+	}
+
+	return (B_FALSE);
+}
+
+/*
  * Find and write ARC buffers to the L2ARC device.
  *
  * An ARC_FLAG_L2_WRITING flag is set so that the L2ARC buffers are not valid
@@ -6910,18 +7885,35 @@
  * the delta by which the device hand has changed due to alignment).
  */
 static uint64_t
-l2arc_write_buffers(spa_t *spa, l2arc_dev_t *dev, uint64_t target_sz)
+l2arc_write_buffers(spa_t *spa, l2arc_dev_t *dev, uint64_t target_sz,
+    l2ad_feed_t feed_type)
 {
 	arc_buf_hdr_t *hdr, *hdr_prev, *head;
+	/*
+	 * We must carefully track the space we deal with here:
+	 * - write_size: sum of the size of all buffers to be written
+	 *	without compression or inter-buffer alignment applied.
+	 *	This size is added to arcstat_l2_size, because subsequent
+	 *	eviction of buffers decrements this kstat by only the
+	 *	buffer's b_lsize (which doesn't take alignment into account).
+	 * - write_asize: sum of the size of all buffers to be written
+	 *	with inter-buffer alignment applied.
+	 *	This size is used to estimate the maximum number of bytes
+	 *	we could take up on the device and is thus used to gauge how
+	 *	close we are to hitting target_sz.
+	 */
 	uint64_t write_asize, write_psize, write_lsize, headroom;
 	boolean_t full;
 	l2arc_write_callback_t *cb;
 	zio_t *pio, *wzio;
+	enum l2arc_priorities try;
 	uint64_t guid = spa_load_guid(spa);
+	boolean_t dev_hdr_update = B_FALSE;
 
 	ASSERT3P(dev->l2ad_vdev, !=, NULL);
 
 	pio = NULL;
+	cb = NULL;
 	write_lsize = write_asize = write_psize = 0;
 	full = B_FALSE;
 	head = kmem_cache_alloc(hdr_l2only_cache, KM_PUSHPAGE);
@@ -6930,7 +7922,7 @@
 	/*
 	 * Copy buffers for L2ARC writing.
 	 */
-	for (int try = 0; try <= 3; try++) {
+	for (try = PRIORITY_MFU_DDT; try < PRIORITY_NUMTYPES; try++) {
 		multilist_sublist_t *mls = l2arc_sublist_lock(try);
 		uint64_t passed_sz = 0;
 
@@ -7000,6 +7992,15 @@
 				break;
 			}
 
+			/* make sure buf we select corresponds to feed_type */
+			if ((feed_type == L2ARC_FEED_DDT_DEV &&
+			    arc_buf_type(hdr) != ARC_BUFC_DDT) ||
+			    (feed_type == L2ARC_FEED_NON_DDT_DEV &&
+			    arc_buf_type(hdr) == ARC_BUFC_DDT)) {
+					mutex_exit(hash_lock);
+					continue;
+			}
+
 			if (pio == NULL) {
 				/*
 				 * Insert a dummy header on the buflist so
@@ -7010,10 +8011,13 @@
 				list_insert_head(&dev->l2ad_buflist, head);
 				mutex_exit(&dev->l2ad_mtx);
 
-				cb = kmem_alloc(
+				cb = kmem_zalloc(
 				    sizeof (l2arc_write_callback_t), KM_SLEEP);
 				cb->l2wcb_dev = dev;
 				cb->l2wcb_head = head;
+				list_create(&cb->l2wcb_log_blk_buflist,
+				    sizeof (l2arc_log_blk_buf_t),
+				    offsetof(l2arc_log_blk_buf_t, lbb_node));
 				pio = zio_root(spa, l2arc_write_done, cb,
 				    ZIO_FLAG_CANFAIL);
 			}
@@ -7048,7 +8052,7 @@
 				to_write = hdr->b_l1hdr.b_pabd;
 			} else {
 				to_write = abd_alloc_for_io(asize,
-				    HDR_ISTYPE_METADATA(hdr));
+				    !HDR_ISTYPE_DATA(hdr));
 				abd_copy(to_write, hdr->b_l1hdr.b_pabd, psize);
 				if (asize != psize) {
 					abd_zero_off(to_write, psize,
@@ -7074,6 +8078,15 @@
 			mutex_exit(hash_lock);
 
 			(void) zio_nowait(wzio);
+
+			/*
+			 * Append buf info to current log and commit if full.
+			 * arcstat_l2_{size,asize} kstats are updated internally.
+			 */
+			if (l2arc_log_blk_insert(dev, hdr)) {
+				l2arc_log_blk_commit(dev, pio, cb);
+				dev_hdr_update = B_TRUE;
+			}
 		}
 
 		multilist_sublist_unlock(mls);
@@ -7090,9 +8103,18 @@
 		return (0);
 	}
 
+	/*
+	 * If we wrote any logs as part of this write, update dev hdr
+	 * to point to it.
+	 */
+	if (dev_hdr_update)
+		l2arc_dev_hdr_update(dev, pio);
+
 	ASSERT3U(write_asize, <=, target_sz);
 	ARCSTAT_BUMP(arcstat_l2_writes_sent);
 	ARCSTAT_INCR(arcstat_l2_write_bytes, write_psize);
+	if (feed_type == L2ARC_FEED_DDT_DEV)
+		ARCSTAT_INCR(arcstat_l2_ddt_write_bytes, write_psize);
 	ARCSTAT_INCR(arcstat_l2_lsize, write_lsize);
 	ARCSTAT_INCR(arcstat_l2_psize, write_psize);
 	vdev_space_update(dev->l2ad_vdev, write_psize, 0, 0);
@@ -7101,7 +8123,8 @@
 	 * Bump device hand to the device start if it is approaching the end.
 	 * l2arc_evict() will already have evicted ahead for this case.
 	 */
-	if (dev->l2ad_hand >= (dev->l2ad_end - target_sz)) {
+	if (dev->l2ad_hand + target_sz + l2arc_log_blk_overhead(target_sz) >=
+	    dev->l2ad_end) {
 		dev->l2ad_hand = dev->l2ad_start;
 		dev->l2ad_first = B_FALSE;
 	}
@@ -7113,6 +8136,56 @@
 	return (write_asize);
 }
 
+static boolean_t
+l2arc_feed_dev(l2ad_feed_t feed_type, uint64_t *wrote)
+{
+	spa_t *spa;
+	l2arc_dev_t *dev;
+	uint64_t size;
+
+	/*
+	 * This selects the next l2arc device to write to, and in
+	 * doing so the next spa to feed from: dev->l2ad_spa.   This
+	 * will return NULL if there are now no l2arc devices or if
+	 * they are all faulted.
+	 *
+	 * If a device is returned, its spa's config lock is also
+	 * held to prevent device removal.  l2arc_dev_get_next()
+	 * will grab and release l2arc_dev_mtx.
+	 */
+	if ((dev = l2arc_dev_get_next(feed_type)) == NULL)
+		return (B_FALSE);
+
+	spa = dev->l2ad_spa;
+	ASSERT(spa != NULL);
+
+	/*
+	 * If the pool is read-only - skip it
+	 */
+	if (!spa_writeable(spa)) {
+		spa_config_exit(spa, SCL_L2ARC, dev);
+		return (B_FALSE);
+	}
+
+	ARCSTAT_BUMP(arcstat_l2_feeds);
+	size = l2arc_write_size();
+
+	/*
+	 * Evict L2ARC buffers that will be overwritten.
+	 * B_FALSE guarantees synchronous eviction.
+	 */
+	(void) l2arc_evict(dev, size, B_FALSE);
+
+	/*
+	 * Write ARC buffers.
+	 */
+	*wrote = l2arc_write_buffers(spa, dev, size, feed_type);
+
+	spa_config_exit(spa, SCL_L2ARC, dev);
+
+	return (B_TRUE);
+}
+
 /*
  * This thread feeds the L2ARC at regular intervals.  This is the beating
  * heart of the L2ARC.
@@ -7122,10 +8195,9 @@
 l2arc_feed_thread(void *unused)
 {
 	callb_cpr_t cpr;
-	l2arc_dev_t *dev;
-	spa_t *spa;
-	uint64_t size, wrote;
+	uint64_t size, total_written = 0;
 	clock_t begin, next = ddi_get_lbolt();
+	l2ad_feed_t feed_type = L2ARC_FEED_ALL;
 
 	CALLB_CPR_INIT(&cpr, &l2arc_feed_thr_lock, callb_generic_cpr, FTAG);
 
@@ -7150,59 +8222,33 @@
 		begin = ddi_get_lbolt();
 
 		/*
-		 * This selects the next l2arc device to write to, and in
-		 * doing so the next spa to feed from: dev->l2ad_spa.   This
-		 * will return NULL if there are now no l2arc devices or if
-		 * they are all faulted.
-		 *
-		 * If a device is returned, its spa's config lock is also
-		 * held to prevent device removal.  l2arc_dev_get_next()
-		 * will grab and release l2arc_dev_mtx.
-		 */
-		if ((dev = l2arc_dev_get_next()) == NULL)
-			continue;
-
-		spa = dev->l2ad_spa;
-		ASSERT3P(spa, !=, NULL);
-
-		/*
-		 * If the pool is read-only then force the feed thread to
-		 * sleep a little longer.
-		 */
-		if (!spa_writeable(spa)) {
-			next = ddi_get_lbolt() + 5 * l2arc_feed_secs * hz;
-			spa_config_exit(spa, SCL_L2ARC, dev);
-			continue;
-		}
-
-		/*
 		 * Avoid contributing to memory pressure.
 		 */
 		if (arc_reclaim_needed()) {
 			ARCSTAT_BUMP(arcstat_l2_abort_lowmem);
-			spa_config_exit(spa, SCL_L2ARC, dev);
 			continue;
 		}
 
-		ARCSTAT_BUMP(arcstat_l2_feeds);
+		/* try to write to DDT L2ARC device if any */
+		if (l2arc_feed_dev(L2ARC_FEED_DDT_DEV, &size)) {
+			total_written += size;
+			feed_type = L2ARC_FEED_NON_DDT_DEV;
+		}
 
-		size = l2arc_write_size();
+		/* try to write to the regular L2ARC device if any */
+		if (l2arc_feed_dev(feed_type, &size)) {
+			total_written += size;
+			if (feed_type == L2ARC_FEED_NON_DDT_DEV)
+				total_written /= 2; /* avg written per device */
+		}
 
 		/*
-		 * Evict L2ARC buffers that will be overwritten.
-		 */
-		l2arc_evict(dev, size, B_FALSE);
-
-		/*
-		 * Write ARC buffers.
-		 */
-		wrote = l2arc_write_buffers(spa, dev, size);
-
-		/*
 		 * Calculate interval between writes.
 		 */
-		next = l2arc_write_interval(begin, size, wrote);
-		spa_config_exit(spa, SCL_L2ARC, dev);
+		next = l2arc_write_interval(begin, l2arc_write_size(),
+		    total_written);
+
+		total_written = 0;
 	}
 
 	l2arc_thread_exit = 0;
@@ -7214,25 +8260,39 @@
 boolean_t
 l2arc_vdev_present(vdev_t *vd)
 {
-	l2arc_dev_t *dev;
+	return (l2arc_vdev_get(vd) != NULL);
+}
 
-	mutex_enter(&l2arc_dev_mtx);
+/*
+ * Returns the l2arc_dev_t associated with a particular vdev_t or NULL if
+ * the vdev_t isn't an L2ARC device.
+ */
+static l2arc_dev_t *
+l2arc_vdev_get(vdev_t *vd)
+{
+	l2arc_dev_t	*dev;
+	boolean_t	held = MUTEX_HELD(&l2arc_dev_mtx);
+
+	if (!held)
+		mutex_enter(&l2arc_dev_mtx);
 	for (dev = list_head(l2arc_dev_list); dev != NULL;
 	    dev = list_next(l2arc_dev_list, dev)) {
 		if (dev->l2ad_vdev == vd)
 			break;
 	}
-	mutex_exit(&l2arc_dev_mtx);
+	if (!held)
+		mutex_exit(&l2arc_dev_mtx);
 
-	return (dev != NULL);
+	return (dev);
 }
 
 /*
  * Add a vdev for use by the L2ARC.  By this point the spa has already
- * validated the vdev and opened it.
+ * validated the vdev and opened it. The `rebuild' flag indicates whether
+ * we should attempt an L2ARC persistency rebuild.
  */
 void
-l2arc_add_vdev(spa_t *spa, vdev_t *vd)
+l2arc_add_vdev(spa_t *spa, vdev_t *vd, boolean_t rebuild)
 {
 	l2arc_dev_t *adddev;
 
@@ -7244,11 +8304,17 @@
 	adddev = kmem_zalloc(sizeof (l2arc_dev_t), KM_SLEEP);
 	adddev->l2ad_spa = spa;
 	adddev->l2ad_vdev = vd;
-	adddev->l2ad_start = VDEV_LABEL_START_SIZE;
+	/* leave extra size for an l2arc device header */
+	adddev->l2ad_dev_hdr_asize = MAX(sizeof (*adddev->l2ad_dev_hdr),
+	    1 << vd->vdev_ashift);
+	adddev->l2ad_start = VDEV_LABEL_START_SIZE + adddev->l2ad_dev_hdr_asize;
 	adddev->l2ad_end = VDEV_LABEL_START_SIZE + vdev_get_min_asize(vd);
+	ASSERT3U(adddev->l2ad_start, <, adddev->l2ad_end);
 	adddev->l2ad_hand = adddev->l2ad_start;
 	adddev->l2ad_first = B_TRUE;
 	adddev->l2ad_writing = B_FALSE;
+	adddev->l2ad_dev_hdr = kmem_zalloc(adddev->l2ad_dev_hdr_asize,
+	    KM_SLEEP);
 
 	mutex_init(&adddev->l2ad_mtx, NULL, MUTEX_DEFAULT, NULL);
 	/*
@@ -7267,6 +8333,16 @@
 	mutex_enter(&l2arc_dev_mtx);
 	list_insert_head(l2arc_dev_list, adddev);
 	atomic_inc_64(&l2arc_ndev);
+	if (rebuild && l2arc_rebuild_enabled &&
+	    adddev->l2ad_end - adddev->l2ad_start > L2ARC_PERSIST_MIN_SIZE) {
+		/*
+		 * Just mark the device as pending for a rebuild. We won't
+		 * be starting a rebuild in line here as it would block pool
+		 * import. Instead spa_load_impl will hand that off to an
+		 * async task which will call l2arc_spa_rebuild_start.
+		 */
+		adddev->l2ad_rebuild = B_TRUE;
+	}
 	mutex_exit(&l2arc_dev_mtx);
 }
 
@@ -7292,21 +8368,46 @@
 	ASSERT3P(remdev, !=, NULL);
 
 	/*
+	 * Cancel any ongoing or scheduled rebuild (race protection with
+	 * l2arc_spa_rebuild_start provided via l2arc_dev_mtx).
+	 */
+	remdev->l2ad_rebuild_cancel = B_TRUE;
+	if (remdev->l2ad_rebuild_did != 0) {
+		/*
+		 * N.B. it should be safe to thread_join with the rebuild
+		 * thread while holding l2arc_dev_mtx because it is not
+		 * accessed from anywhere in the l2arc rebuild code below
+		 * (except for l2arc_spa_rebuild_start, which is ok).
+		 */
+		thread_join(remdev->l2ad_rebuild_did);
+	}
+
+	/*
 	 * Remove device from global list
 	 */
 	list_remove(l2arc_dev_list, remdev);
 	l2arc_dev_last = NULL;		/* may have been invalidated */
+	l2arc_ddt_dev_last = NULL;	/* may have been invalidated */
 	atomic_dec_64(&l2arc_ndev);
 	mutex_exit(&l2arc_dev_mtx);
 
+	if (vdev_type_is_ddt(remdev->l2ad_vdev))
+		atomic_add_64(&remdev->l2ad_spa->spa_l2arc_ddt_devs_size,
+		    -(vdev_get_min_asize(remdev->l2ad_vdev)));
+
 	/*
 	 * Clear all buflists and ARC references.  L2ARC device flush.
 	 */
-	l2arc_evict(remdev, 0, B_TRUE);
-	list_destroy(&remdev->l2ad_buflist);
-	mutex_destroy(&remdev->l2ad_mtx);
-	refcount_destroy(&remdev->l2ad_alloc);
-	kmem_free(remdev, sizeof (l2arc_dev_t));
+	if (l2arc_evict(remdev, 0, B_TRUE) == B_FALSE) {
+		/*
+		 * The eviction was done synchronously, cleanup here
+		 * Otherwise, the asynchronous task will cleanup
+		 */
+		list_destroy(&remdev->l2ad_buflist);
+		mutex_destroy(&remdev->l2ad_mtx);
+		kmem_free(remdev->l2ad_dev_hdr, remdev->l2ad_dev_hdr_asize);
+		kmem_free(remdev, sizeof (l2arc_dev_t));
+	}
 }
 
 void
